#include "Bolt86Lib.inc"	;equ's slow this assembler down SCREW
#include "prgm_lib.h"	;Library programs need this

CUSTOM LIBRARY for Bolt86: Library (demo) version

.org LIB_RAM

	RET	;No, stupid user, DONT RUN LIBRARIES!

PutSpriteMask: ;Modified by Scabbers for slight speed optimization, instead of sprite in hl[push hl\pop ix]
		   ;78 bytes, 403 t-States
	;Sprite in <IX>
	;Location in <bc>
	;'FALLUP??' SUCKS!
 call FindAddress					; calc address and offset

PutSpriteE:
 ld de,$FC00					; draw sprite to video memory

 add hl,de							; add offset to buffer start

RenderSpriteCV =$+1

 ld b,8								; set row counter to 8 bytes

RenderSpriteL:
 push bc							; save row counter and sprite offset

 ld a,(ix+8)						; load mask for this row

RenderSpriteM =$-1

 cpl								; invert the mask

 ld b,a								; save inverted mask

 ld d,(ix)							; load sprite byte for this row

 inc ix								; advance sprite pointer

 ld a,c								; set shift counter to sprite offset

 ld c,$ff							; set all bits of right mask byte

 ld e,0								; clear right byte of sprite

 or a								; is the sprite aligned?

 jr z,RenderSpriteD					; then skip shifting it

RenderSpriteS:
 srl d								; shift left sprite byte

 rr e								; into the right sprite byte

 scf								; set carry

 rr b 								; shift left mask byte

 rr c								; into the right mask byte

 dec a								; decrease shift counter

 jr nz,RenderSpriteS				; loop until counter is 0

RenderSpriteD:
RenderSpriteCL =$

 ld a,b								; load the left sprite byte

 and (hl)							; and it with the screen

 or d								; or it with the mask

 ld (hl),a							; set screen memory to left byte

 inc hl								; increase screen pointer

RenderSpriteCR =$

 ld a,c								; load the right sprite byte

 and (hl)							; and it with the screen

 or e								; or it with the mask

 ld (hl),a							; set screen memory to left byte

 ld de,15							; next row is 15 bytes ahead

 add hl,de							; move screen pointer to next row

 pop bc								; restore loop counter and shift mask

 djnz RenderSpriteL					; loop for all bytes in sprite

 ret								; done drawing the sprite

; in: bc = x,y location

; out: hl = offset of byte, c = offset in video byte

FindAddress:
 ld a,c								; get the y coord

 add a,a							; multiply by 2

 add a,a							; again by 4

 ld l,a								; save as low byte

 ld h,0								; clear high byte

 add hl,hl							; multiply by 8

 add hl,hl							; and again by 16

 ld a,b								; now get the x coord

 and %11111000						; clear lower 3 bits

 rra								; divide by 2

 rra								; this time by 4

 rra								; and finally by 8

 or l								; combine with low byte

 ld l,a								; save it

 ld a,b								; get x coord again

 and %00000111						; clear all but last 3 bits

 ld c,a								; save sprite offset in c

 ret								; return to caller


WriteBack:		;We're gonna be calling this many times...

	ld hl,_asapvar			;hl->name of program

	rst 20h				;copy to OP1

	rst 10h				;_findsym

	xor a

	ld hl,data_start-_asm_exec_ram+4		;offset

	add hl,de				;hl=pointer to data in original prog

	adc a,b				;in case we overlapped pages

	call _SET_ABS_DEST_ADDR

	xor a					;no absolute addressing now

	ld hl,data_start			;get data from here

	call _SET_ABS_SRC_ADDR

	ld hl,data_end-data_start	;number of bytes to save

	call _SET_MM_NUM_BYTES

	jp _MM_LDIR			;copy data and return

cphlNde:
	;compares hl to de

	;already in rom, but since we're swapping pages, can't

	;rely on it being there. this is identical routine

	;Also faster.

	push hl					;save hl

	or a						;reset carry flag

	sbc hl,de					;subtract de from hl and store in hl

	pop hl					;restore hl (all that was affected by subtraction was flags)

	ret						;return


#INCLUDE "PASSWORDIN.ASM"		;MY OWN ROUTINE. TEXTIN USES _GETKEY, WHICH IS USELESS.
ClearWorkArea:
;==========================================
; clear_screen by jimi (malcolmj1@juno.com)
; input:	none
: output:	all bits in video mem reset
; destroy:	bc,de,hl
; clock cycles:	71 t-states
; size:		14 bytes
;==========================================
	ld hl,$fC80	;start of video memory
	ld (hl),0
	ld de,$fC81	;2nd byte in video mem
	ld bc,895	;size of video mem-1
	ldir		;copy already cleared
	ret		;we're done
ClearPlotSScreen:	;for DialogBox and the like
;==========================================
; clear_screen by jimi (malcolmj1@juno.com)
; input:	none
: output:	all bits in graph mem reset
; destroy:	bc,de,hl
; clock cycles:	71 t-states
; size:		14 bytes
;==========================================
	ld hl,_plotSScreen
	ld de,_plotSScreen+1
	ld (hl),0
	ld bc,1024
	ldir
	ret		;we're done
#INCLUDE "DIALOGBOX.ASM"

Put_Big_Bar:		;af, b, hl destroyed
	ld hl, $FC00
	ld a,$FF
	ld b,128
PBB_Loop1:
	ld (hl),a
	inc hl
	djnz PBB_Loop1
	ret

About:
	ld hl,Title
	ld de,Ver
	call DialogBox
	ld a,$FF		;So Setup/Option Menu won't go to something 'automatically'(cp)
	ld a,17
	ld (_penCol),a
	ld a,39
	ld (_penRow),a
	ld hl,Company
	call _vputs
	call _getkey
	pop hl
	ld de,$D7E0
	call cphlNde
	jp z,SetupMenu
	jp nz,OptionMenu


.end
