;#include "ram86.h"	;equ's slow this assembler down SCREW
#include "prgm_lib.h"	;Library programs need this

.org LIB_RAM
	RET	;No, stupid user, DONT RUN LIBRARIES!
PutSpriteMask: ;Modified by Scabbers for slight speed optimization, instead of sprite in hl[push hl\pop ix]
		   ;78 bytes, 403 t-States
	;Sprite in <IX>
	;Location in <bc>
	;FALLUP SUCKS!
 call FindAddress					; calc address and offset

PutSpriteE:
 ld de,$FC00					; draw sprite to video memory

 add hl,de							; add offset to buffer start

RenderSpriteCV =$+1

 ld b,8								; set row counter to 8 bytes

RenderSpriteL:
 push bc							; save row counter and sprite offset

 ld a,(ix+8)						; load mask for this row

RenderSpriteM =$-1

 cpl								; invert the mask

 ld b,a								; save inverted mask

 ld d,(ix)							; load sprite byte for this row

 inc ix								; advance sprite pointer

 ld a,c								; set shift counter to sprite offset

 ld c,$ff							; set all bits of right mask byte

 ld e,0								; clear right byte of sprite

 or a								; is the sprite aligned?

 jr z,RenderSpriteD					; then skip shifting it

RenderSpriteS:
 srl d								; shift left sprite byte

 rr e								; into the right sprite byte

 scf								; set carry

 rr b 								; shift left mask byte

 rr c								; into the right mask byte

 dec a								; decrease shift counter

 jr nz,RenderSpriteS				; loop until counter is 0

RenderSpriteD:
RenderSpriteCL =$

 ld a,b								; load the left sprite byte

 and (hl)							; and it with the screen

 or d								; or it with the mask

 ld (hl),a							; set screen memory to left byte

 inc hl								; increase screen pointer

RenderSpriteCR =$

 ld a,c								; load the right sprite byte

 and (hl)							; and it with the screen

 or e								; or it with the mask

 ld (hl),a							; set screen memory to left byte

 ld de,15							; next row is 15 bytes ahead

 add hl,de							; move screen pointer to next row

 pop bc								; restore loop counter and shift mask

 djnz RenderSpriteL					; loop for all bytes in sprite

 ret								; done drawing the sprite

; in: bc = x,y location

; out: hl = offset of byte, c = offset in video byte

FindAddress:
 ld a,c								; get the y coord

 add a,a							; multiply by 2

 add a,a							; again by 4

 ld l,a								; save as low byte

 ld h,0								; clear high byte

 add hl,hl							; multiply by 8

 add hl,hl							; and again by 16

 ld a,b								; now get the x coord

 and %11111000						; clear lower 3 bits

 rra								; divide by 2

 rra								; this time by 4

 rra								; and finally by 8

 or l								; combine with low byte

 ld l,a								; save it

 ld a,b								; get x coord again

 and %00000111						; clear all but last 3 bits

 ld c,a								; save sprite offset in c

 ret								; return to caller


.end
