#include "ti86asm.inc"
#include "prgm_lib.h"	;Library programs need this
#include "GFL.inc"	;equates for GFL

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle
	.dw Lib		;Note this! Used for FUTURE SHELLS! (like LibShell)
Lib:
	.db 3,"GFL"		;Zero-terminated!
ShellTitle:
	.db "LIB: GFL needed",0

ProgStart:
	call RelocateLib
	ld ix,NewSprite
	ld bc,0
	jp PutSpriteMask
RelocateLib:		;ROUTINE OPTIMIZED FOR SIZE!
;36 bytes
;178 t-states
;This excludes 'SorryLibNotFound' and the lib name
	ld hl,Lib-1			;hl->name of program

	rst 20h				;copy to OP1

	rst 10h				;_findsym

	jp c,SorryLibNotFound	;MUST HAVE STUPID LIB!
	call _ex_ahl_bde	;ROM calls all use AHL
	call _AHL_Plus_2_Pg3
	call _AHL_Plus_2_Pg3
	call _SET_ABS_SRC_ADDR

	xor a					;no absolute addressing now

	ld hl,$F700			;get data from here


	call _SET_ABS_DEST_ADDR


	ld hl,980	;number of bytes to save


	call _SET_MM_NUM_BYTES

	jp _MM_LDIR			;copy data and return


SorryLibNotFound:
	pop hl
	call _homeup
	ld hl,Uhoh
	call _puts
	jp _getkey
Uhoh:
	.db "'GFL' NOT FOUND!!!",0
NewSprite:
	.db %10010100
	.db %10000100
	.db %10010110
	.db %11010110
	.db %00000000
	.db %11111111
	.db %10000001
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %10000001
	.db %11111111

.end
